*********************************************************************
* Title   : DBOpen
* Purpose : Opens a database or selects work area and sets 
* the order to a specified tag
*********************************************************************
* Pre Condition : user sends name of database and tag
* at least one free work area must exist
* Post Condition : database is left open in the appropriate order
* user is placed in the correct work area.
*********************************************************************
PARAMETERS m.theDB,m.theTag

IF USED(m.theDB)
   SELECT (m.theDB)
ELSE
   SELECT 0
   USE (m.theDB)
ENDIF
SET ORDER TO (m.theTag)

RETURN .T.
