PROCEDURE ClipVal

IF NOT ValidMsg()
	RETURN
ENDIF


PRIVATE m.beepPart,m.ifPart,m.bodyPart,m.notesPart,m.progEOL


c_CR=CHR(13)
c_QUOTES=CHR(34)
m.progEOL=';'+c_CR
m.beepPart=IIF(m.chkBeep,'?? CHR(7)'+CHR(13),'')
m.ifPart=IIF(m.chkIF,'IF ','=')
m.notesPart=IIF(m.chkAnnotate,;
'* Type  : '+a_type[m.lstType,1]+c_CR+;
'* Icon  : '+a_icon[m.lstIcon,1]+c_CR+;
'* Focus : '+a_focus[m.lstFocus,1]+c_CR+;
IIF(m.chkIF,'* Answer: '+a_answer[m.lstAnswer,1],'')+c_CR,'')

m.NumOrCons=IIF(m.chkConstants,3,2)

m.bodyPart=;
'MsgBox('+m.progEOL+c_QUOTES+;
IIF(;
EMPTY(m.message),;
	m.noMessage,; 
	MsgStr();
	)+;
c_QUOTES+','+m.progEOL+c_QUOTES+;
IIF(;
	EMPTY(m.title),;
	m.noTitle,;
	ALLTRIM(m.title);
	)+;
c_QUOTES+','+m.progEOL+;
IIF(m.chkConstants,;
a_type[m.lstType,3]+'+'+a_icon[m.lstIcon,3]+'+'+a_focus[m.lstFocus,3],;
ALLTRIM(STR((a_type[m.lstType,2]+a_icon[m.lstIcon,2]+;
a_focus[m.lstFocus,2]))))+')'

m.answerPart=IIF(m.chkIF,'='+;
IIF(m.chkConstants,a_answer[m.lstAnswer,3],;
ALLTRIM(STR(a_answer[m.lstAnswer,m.NumOrCons]))),"")

_CLIPTEXT=m.notesPart+m.beepPart+m.ifPart+m.bodyPart+m.answerPart

?? CHR(7)
WAIT WINDOW "Text pasted to clipboard" TIMEOUT 5


RETURN

PROCEDURE ValidMsg

DO CASE
	CASE (m.lstType=1) AND ((NOT m.lstfocus=1) OR (m.chkIF AND NOT m.lstAnswer=1))

	CASE (m.lstType=2) AND ((NOT INLIST(a_focus[m.lstfocus,2],0,256)) OR (m.chkIF AND NOT INLIST(a_answer[m.lstAnswer,2],1,2)))


	CASE (m.lstType=3) AND ((NOT INLIST(a_focus[m.lstfocus,2],0,256,512)) OR (m.chkIF AND NOT INLIST(a_answer[m.lstAnswer,2],3,4,5)))

	CASE (m.lstType=4) AND ((NOT INLIST(a_focus[m.lstfocus,2],0,256,512)) OR (m.chkIF AND NOT INLIST(a_answer[m.lstAnswer,2],2,6,7)))

	CASE (m.lstType=5) AND ((NOT INLIST(a_focus[m.lstfocus,2],0,256)) OR (m.chkIF AND NOT INLIST(a_answer[m.lstAnswer,2],6,7)))

	CASE (m.lstType=6) AND ((NOT INLIST(a_focus[m.lstfocus,2],0,256)) OR (m.chkIF AND NOT INLIST(a_answer[m.lstAnswer,2],2,4)))

	OTHERWISE
		RETURN .T.
ENDCASE

?? CHR(7)
=MsgBox("Inappropriate focus or answer selections for this type of message.","Message Box Error",0+48+0)

RETURN .F.

PROCEDURE MsgStr


PRIVATE m.noOfCRs,c_CR,c_QUOTES,CRLoop,m.returnVal,m.pointer

m.noOfCRs=OCCURS(CHR(13),m.message)
m.returnVal=""
m.pointer=1

IF m.noOfCRs=0
	RETURN m.message
ENDIF

c_CR=CHR(13)
c_QUOTES=CHR(34)

FOR m.CRLoop=1 TO noOfCRs
	m.returnVal=m.returnVal+;
	c_QUOTES+;
	SUBSTR(m.message,m.pointer,AT(c_CR,m.message,m.CRLoop)-m.pointer)+;
	c_QUOTES+'+ ;'+c_CR+;
	"CHR(13)+;"+c_CR

	m.pointer=AT(c_CR,m.message,m.CRLoop)+2
ENDFOR
m.returnVal=;
m.returnVal+IIF(m.pointer<LEN(m.message),;
c_QUOTES+SUBSTR(m.message,m.pointer),"")

m.returnVal=SUBSTR(m.returnVal,2)
RETURN m.returnVal
	
	



